unit Unit2;

interface

uses
  UnitZpracovaniZdrojovehoKodu, Classes {$IFDEF MSWINDOWS} , Windows {$ENDIF};

type
  ZpracovaniProcedury = class(TThread)
  private
    zpracovani: ZpracovaniZdrojovehoKodu;
    procedure SetName;
  protected
    procedure Execute; override;
  public
    constructor Create (const pZpracovani: ZpracovaniZdrojovehoKodu);
    destructor Free;
  end;

implementation


constructor ZpracovaniProcedury.Create (const pZpracovani: ZpracovaniZdrojovehoKodu);
begin
    inherited Create (false);
    zpracovani := pZpracovani;
    FreeOnTerminate := true;
end;


destructor ZpracovaniProcedury.Free;
begin
    zpracovani.Destroy;
    inherited Free;
end;


{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ZpracovaniProcedury.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{$IFDEF MSWINDOWS}
type
  TThreadNameInfo = record
    FType: LongWord;     // must be 0x1000
    FName: PChar;        // pointer to name (in user address space)
    FThreadID: LongWord; // thread ID (-1 indicates caller thread)
    FFlags: LongWord;    // reserved for future use, must be zero
  end;
{$ENDIF}

{ ZpracovaniProcedury }

procedure ZpracovaniProcedury.SetName;
{$IFDEF MSWINDOWS}
var
  ThreadNameInfo: TThreadNameInfo;
{$ENDIF}
begin
{$IFDEF MSWINDOWS}
  ThreadNameInfo.FType := $1000;
  ThreadNameInfo.FName := 'ZpracovaniProcedury';
  ThreadNameInfo.FThreadID := $FFFFFFFF;
  ThreadNameInfo.FFlags := 0;

  try
    RaiseException( $406D1388, 0, sizeof(ThreadNameInfo) div sizeof(LongWord), @ThreadNameInfo );
  except
  end;
{$ENDIF}
end;

procedure ZpracovaniProcedury.Execute;
begin
  SetName;
  { Place thread code here }
  FreeOnTerminate := true;
  Zpracovani.Execute;
  Zpracovani.Destroy;
end;

end.
 