unit UnitEditaceProcedury;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
        Dialogs, StdCtrls, ComCtrls, Menus, UnitDialogUlozitProceduru, UnitObecnyDatovyTyp,
  UnitRetezcoveProcedury, UnitDefiniceVyjimek;

const MAXPARAM = 15;

type


  TForm2 = class(TForm)
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    Procedura1: TMenuItem;
    Ulo1: TMenuItem;
    Z1: TMenuItem;
    pravy1: TMenuItem;
    Krokzpt1: TMenuItem;
    N1: TMenuItem;
    Vystihnitext1: TMenuItem;
    Koprujtext1: TMenuItem;
    Vlotext1: TMenuItem;
    N2: TMenuItem;
    Oznaceltext1: TMenuItem;
    procedure odradkuj;
    procedure provedBackSpace;
    procedure FormResize(Sender: TObject);
    procedure Z1Click(Sender: TObject);
    procedure Krokzpt1Click(Sender: TObject);
    procedure Vystihnitext1Click(Sender: TObject);
    procedure Koprujtext1Click(Sender: TObject);
    procedure Vlotext1Click(Sender: TObject);
    procedure Oznaceltext1Click(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
  private
    function mezeryOdZacatku (i, d: integer): integer; overload;
    function mezeryOdZacatku (i: integer): integer; overload;
    procedure naZacatek (var i: integer);
    function oKolik: integer;
  public
  end;


implementation

{$R *.dfm}

procedure TForm2.FormResize(Sender: TObject);
{zmena velikosti okna zpusobi i zmenu velikosti komponent}
begin
    Edit2.Width := ClientWidth - 2;
    RichEdit1.Width := ClientWidth - 2;
    RichEdit1.Height := ClientHeight - 89;
end;


function TForm2.mezeryOdZacatku (i, d: integer): integer;
{spocita, kolik znaku mezera se nachazi od pozice i po prvni
 nemezerovy znak, nejvyse vsak po pozici d}
var j: integer;
begin
    j := i + 1;
    while (j < d) and (RichEdit1.Text[j] = ' ') do inc (j);
    mezeryOdZacatku := j - i - 1;
end;


function TFOrm2.mezeryOdZacatku (i: integer): integer;
{spocita, kolik mezer se nachazi pred pozici i az po prvni
 nemezerovy znak, nejvyse vsak po zacatek radky}
var j: integer;
begin
    j := i;
    while (j > 0) and (RichEdit1.Text[j] = ' ') do dec (j);
    if (j > 0) and (RichEdit1.Text[j] <> #10) then mezeryOdZacatku := 0
                                              else mezeryOdZacatku := i - j;
end;


procedure TForm2.naZacatek (var i: integer);
{posune index i tesne pred prvni znak aktualni radky}
begin
    while (i > 0) and (RichEdit1.Text[i] <> #10) do dec (i);
end;


function TForm2.oKolik: integer;
{vrati, kolik mezer se ma smazat, stikne-li uzivatel backspace,
 provadi jednoduche formatovani -- z beznych editoru zname jako autoindent}
var min, akt, i, l: integer;
begin
  with RichEdit1 do begin
    i := SelStart;
    l := length (Text);
    min := mezeryOdZacatku (i);
    if min = 0 then begin
             if i = 0 then oKolik := 0
        else if Text[i] = #10 then oKolik := 2
        else oKolik := 1;
    end else begin
        naZacatek (i);
        dec (i);
        while i > 0 do begin
            naZacatek (i);
            akt := mezeryOdZacatku (i, l);
            if akt < min then begin oKolik := min - akt; exit; end;
            dec (i);
        end; {of while}
        oKolik := min;
    end; {of if}
  end; {of with}
end;


procedure TForm2.odradkuj;
{jednoduche formatovani -- odsazeni pri stisku ENTER}
var i, n: integer;
begin
    with RichEdit1 do begin
        i := SelStart;
        n := 0;
        while (i > 0) and (Text[i] <> #10) do begin
            if Text[i] = ' ' then inc (n)
                             else n := 0;
            dec (i);
        end;
        SelText := #13 + #10;
        for i := 1 to n do SelText := ' ';
    end;
end;


procedure TForm2.provedBackSpace;
{jednoduche formatovani, smaze vice mezer najednou}
var n: integer;
begin
    with RichEdit1 do begin
        n := oKolik;
        SelStart := SelStart - n;
        SelLength := n;
        SelText := '';
    end;
end;


procedure TForm2.Z1Click(Sender: TObject);
{Kliknuti na polozku menu "zavrit okno".}
begin
    Close;
end;


procedure TForm2.Krokzpt1Click(Sender: TObject);
begin
    RichEdit1.Undo;
end;

procedure TForm2.Vystihnitext1Click(Sender: TObject);
begin
    RichEdit1.CutToClipboard;
end;

procedure TForm2.Koprujtext1Click(Sender: TObject);
begin
    RichEdit1.CopyToClipboard;
end;

procedure TForm2.Vlotext1Click(Sender: TObject);
begin
    RichEdit1.PasteFromClipboard;
end;

procedure TForm2.Oznaceltext1Click(Sender: TObject);
begin
    RichEdit1.SelectAll;
end;

procedure TForm2.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = 8 then begin
        Key := 0;
        provedBackspace;
    end;
end;

procedure TForm2.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then begin
        Key := #0;
        odradkuj;
    end;
end;

end.
