unit UnitHlavniOkno;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Contnrs,
  Forms, Dialogs, StdCtrls, UnitProcedura, ExtCtrls, ZImage,
  UnitDialogVytvoreniNoveProcedury, UnitRetezcoveProcedury, UnitObecnyDatovyTyp,
  UnitDefiniceVyjimek, UnitPromenne, UnitZasobnikyParametruAPozic,
  UnitZpracovaniZdrojovehoKodu, UnitDialogUlozitDoSouboru,
  UnitJmenoSouboruExistuje, UnitNacteniPromenne, UnitNacteniLogickePromenne,
  UnitSmazatProceduru, ToolWin, ComCtrls, ImgList;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    ZImage1: TZImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ImageList1: TImageList;  {ikonky na panelu nastroju}
    ToolButton11: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
  private
    zpracovani: ZpracovaniZdrojovehoKodu;
    jmenoSouboru: String;
    novy: boolean;
    procedure nahrat;
    function nekolidujeSKeyword (const slovo: String): boolean;
        {true pokud parametr neni nazvem prikazu}
    function smazProcedury: boolean;
    procedure ulozZmeny;
    procedure ulozJako;
    function doplnZgr (filename: String): String;
    procedure novyProjekt;
    procedure obnovPrvky (Sender: TObject);
  public
  end;


var
  Form1: TForm1;

implementation

{$R *.dfm}


function TForm1.smazProcedury: boolean;
{projde seznam procedur v ListBox1, smaze zaznam v listboxu a zavola destruktor}
var i: integer;
begin
    for i := 0 to ListBox1.Items.Count - 1 do begin
        Procedura (ListBox1.Items.Objects[0]).Destroy;
        ListBox1.Items.Delete(0);
    end;
end;


function TForm1.nekolidujeSKeyword (const slovo: String): boolean;
begin
    nekolidujeSKeyword := (slovo <> 'vpred')
                      and (slovo <> 'otoc')
                      and (slovo <> 'smaz')
                      and (slovo <> 'opakuj')
                      and (slovo <> 'pokud')
                      and (slovo <> 'zvedni')
                      and (slovo <> 'poloz')
                      and (slovo <> 'tloustka')
                      and (slovo <> 'barva')
                      and (slovo <> 'at')
                      and (slovo <> 'pocitej')
                      and (slovo <> 'zelvicku')
                      and (slovo <> 'dokud')
                      and (slovo <> 'provadej')
                      and (slovo <> 'hodnota')
                      and (slovo <> 'pravdivost')
                      and (slovo <> 'napis');
end; {of nekolidujeSKeyword}


procedure TForm1.novyProjekt;
{stisk tlacitka novy projekt}
begin
    if (tag > 0) and (Form4.ShowModal = mrOK) then begin
        if novy then ulozJako
                else ulozZmeny;
    end;
    smazProcedury;
    novy := true;
    jmenoSouboru := 'novy.zgr';
end;


procedure TForm1.nahrat;
{nahraje projekt ze souboru, vyuziva metodu nahrejProceduru tridy Procedura}
var vstupniSoubor: TextFile;
var nova: Procedura;
begin
    if (tag > 0) and (Form4.ShowModal = mrOK) then begin
        if novy then ulozJako
                else ulozZmeny;
    end;
    if OpenDialog1.Execute then begin
        smazProcedury;
        AssignFile (vstupniSoubor, OpenDialog1.FileName);
        Reset (vstupniSoubor);
        while not eof (vstupniSoubor) do begin
            nova := Procedura.Create (Self);
            ListBox1.Items.AddObject (nova.nactiProceduru (vstupniSoubor), nova);
        end;
        CloseFile (vstupniSoubor);
        jmenoSouboru := OpenDialog1.FileName;
        Tag := 0;
        novy := false;
    end; {of if CanReload}
end;


function TForm1.doplnZgr (filename: String): String;
{zajisti, ze pokud jmeno souboru nekonci na .zgr, bude pripona doplnena}
begin
    if copy (filename, length (filename) - 3, 4) <> '.zgr' then
        filename := filename + '.zgr';
    doplnZgr := filename;
end;


procedure TForm1.ulozJako;
var filename: String;
var hotovo: boolean;
begin
    hotovo := false;
    SaveDialog1.FileName := jmenoSouboru;
    while not hotovo do begin
        if not SaveDialog1.Execute then break;
        filename := doplnZgr (SaveDialog1.FileName);
        if not FileExists (filename) or (Form5.ShowModal = mrOK) then begin
            jmenoSouboru := filename;
            ulozZmeny;
            hotovo := true;
        end; {of if}
    end; {of while}
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
    ZImage1.init;
    tag := 0;
    jmenoSouboru := 'novy.zgr';
    novy := true;
end;


procedure TForm1.obnovPrvky (Sender: TObject);
{kdyz procedura konci, disablovane prvky se opet enabluji}
begin
    ListBox1.Enabled := true;
    ToolButton3.Enabled := true;
    ToolButton1.Enabled := true;
    ToolButton7.Enabled := true;
    ToolButton8.Enabled := true;
end;


procedure TForm1.ListBox1DblClick(Sender: TObject);
{uzivatel kliknul na nazev procedury v seznamu vlevo, procedura se spusti,
 napred se ale disabluji nektere ovladaci prvky, jejichz pouziti by
 zpusobilo nezadouci zasah do behu Zelvovskeho programu}
begin
    with ListBox1 do begin
        zpracovani := ZpracovaniZdrojovehoKodu.Create (
            Procedura (Items.Objects[ItemIndex]),
            ZImage1,
            Items
        );{zpracovani}
        ListBox1.Enabled := false;
        ToolButton3.Enabled := false;
        ToolButton1.Enabled := false;
        ToolButton7.Enabled := false;
        ToolButton8.Enabled := false;
        zpracovani.OnTerminate := obnovPrvky;
        zpracovani.Resume;
    end; {of with}
end;


procedure TForm1.ulozZmeny;
{ulozi projekt do souboru, vyuziva metodu ulozProceduru tridy Procedura}
var vystupniSoubor: TextFile;
var i: integer;
begin
    AssignFile (vystupniSoubor, jmenoSouboru);
    Rewrite (vystupniSoubor);
    for i := 0 to ListBox1.Items.Count - 1 do begin
        Procedura (ListBox1.Items.Objects[i]).ulozProceduru (vystupniSoubor);
    end;
    CloseFile (vystupniSoubor);
    tag := 0;
    novy := false;
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    if (tag > 0) and (Form4.ShowModal = mrOK) then begin
        if novy then ulozJako
                else ulozZmeny;
    end;
end;


procedure TForm1.ToolButton1Click(Sender: TObject);
{stisk tlacitka otevri projekt}
begin
    nahrat;
end;


procedure TForm1.ToolButton2Click(Sender: TObject);
{stisk tlacitka uloz projekt}
begin
    if novy then ulozJako
        else ulozZmeny;
end;


procedure TForm1.ToolButton3Click(Sender: TObject);
{stisk tlacitka novy projekt}
begin
    novyProjekt;
end;


procedure TForm1.ToolButton4Click(Sender: TObject);
{stisk tlacitka uloz jako...}
begin
    ulozJako;
end;


procedure TForm1.ToolButton6Click(Sender: TObject);
{uzivatel kliknul na tlacitko nova proc.}
var noveOkno: Procedura;
begin
    Form6.Edit1.Text := '';
    if Form6.ShowModal = mrOK then begin
        if not jeAlfNum (Form6.Edit1.Text) then
            ShowMessage ('Takto se procedura jmenovat nesm. Mus zanat psmenem anglick abecedy, dle pak me obsahovat jen psmena anglick abecedy a lice.')
        else begin
            if ListBox1.Items.IndexOf (Form6.Edit1.Text) <> -1 then
                raise Exception.Create ('Chyba, procedura s takovm nzvem u existuje.');
            if not nekolidujeSKeyword (Form6.Edit1.Text) then
                raise Exception.Create ('Chyba, takto se procedura jmenovat nesm, zvolen nzev je nzev pkazu.');
            noveOkno := Procedura.Create (Self, Form6.Edit1.Text);
            ListBox1.Items.AddObject(Form6.Edit1.Text, noveOkno);
            noveOkno.Show;
        end;
    end;
end;


procedure TForm1.ToolButton7Click(Sender: TObject);
{stisk tlacitka edituj}
begin
  try
    with ListBox1 do
        (Procedura (Items.Objects[ItemIndex])).Show;
  except
  end;
end;


procedure TForm1.ToolButton8Click(Sender: TObject);
{stisk tlacitka vymazani procedury}
begin
    with ListBox1 do begin
        if (ItemIndex >= 0) and (Form10.ShowModal = mrYes) then begin
            Items.Objects[ItemIndex].Destroy;
            Items.Delete(ItemIndex);
            Self.Tag := 1;
        end; {of if}
   end; {of with}
end;


procedure TForm1.ToolButton9Click(Sender: TObject);
{stisk tlacitka smaz plochu}
begin
    ZImage1.vymazat;
end;


procedure TForm1.ToolButton11Click(Sender: TObject);
{stisk tlacitka zastavit}
begin
    try
        zpracovani.Terminate;
    except
    end;
end;

end.
