unit UnitZpracovaniZdrojovehoKodu;

interface

uses UnitProcedura, UnitRetezcoveProcedury, UnitObecnyDatovyTyp,
     UnitDefiniceVyjimek, UnitZasobnikyParametruAPozic, Dialogs,
     SysUtils, ZImage, Classes, UnitPromenne, UnitNacteniPromenne,
     Controls, UnitNacteniLogickePromenne;

const BILE = [' ', #10, #13]; {bile znaky}
type konPrikaz = (kpKONEC, kpJINAK, kpNEBO, kpERROR);
{vyuzivano procedurou doctiZa jako navratova hodnota -- vraci,
 za jakym prikazem preskakovani kodu skoncilo}


type ZpracovaniZdrojovehoKodu = class (TThread)
  private
    aktPozice: Pozice; {kde se prave nachazime -- strunktura Pozice obsahuje nazev procedury a aktualni znak}
    output: TZImage; {na co se ma kreslit}
    procs: TStrings; {seznam definovanych procedur}
    vrs: Vars; {objekt obsahujici vsechny definovane promenne}
    spustProcedura: Procedura;
    zasob: Zasobniky; {zasobniky parametru a pozic}
    proceduraPrebirajiciParametry: Procedura;
    odpovedModOkna: integer;
    aktE: Exception;
    procedure preskocMezery;
    function prohledniSiSlovo: String;
    function cislo: ODTCislo;
    function promenna: ODTCislo;
    function vyhodnotFunkciSin: ODTCislo;
    function vyhodnotFunkciCos: ODTCislo;
    function vyhodnotFunkciLn: ODTCislo;
    function vyhodnotFunkciLog: ODTCislo;
    function vyhodnotFunkciCelacast: ODTCislo;
    function vyhodnotFunkciZaokrouhlene: ODTCislo;
    function vyhodnotFunkciOdm: ODTCislo;
    procedure pripravVstupniOkno;
    procedure pripravLogOkno;
    function vyhodnotFunkciCti (des: boolean): ODTCislo;
    function vyhodnotFunkciOtazka: ODTLogickaHodnota;
    function vyhodnotFunkci: ODTCislo;
    function faktorPozitivni: ODTCislo;
    function faktor: ODTCislo;
    function clen: ODTCislo;
    function vyraz: ODTCislo;
    function ctiZnamenko: String;
    function compare (const vyr1, vyr2: ODTCislo; const znamenko: String): ODTLogickaHodnota;
    function logickaHodnota: ODTLogickaHodnota;
    function zpracujFunkciOtazka: ODTLogickaHodnota;
    function zpracujFunkciNe: ODTLogickaHodnota;
    function logickaPromenna (var vysledek: ODTLogickaHodnota): boolean;
    function logickyCinitel: ODTLogickaHodnota;
    function logickyScitanec: ODTLogickaHodnota;
    function logickyVyraz: ODTLogickaHodnota;
    procedure zpracujVpred;
    function ctiSlovo: String;
    procedure doctiZaZnak (ch: char);
    function doctiZa: konPrikaz;
    procedure zpracujOtoc;
    procedure zpracujVymazat;
    procedure zpracujZvedni;
    procedure zpracujPoloz;
    procedure zpracujTloustka;
    procedure zpracujBarva;
    procedure vykonejOpakuj (n: integer);
    procedure zpracujOpakuj;
    function nactiJmenoPromenne: String;
    function ctiOdDoPo (co: String): integer;
    procedure vykonejPocitej (a, b, d: integer; const jmenoPromenne: String);
    procedure zpracujPocitej;
    procedure zavolejProceduru (p: TObject);
    procedure zpracujPokudTrue;
    function zpracujPokudFalse: boolean;
    procedure zpracujPokud;
    procedure prirad (const jmenoPromenne: String);
    procedure vytvorPromennou (const jmenoPromenne: String);
    procedure inicializujPromennou;
    procedure zpracujAt;
    procedure zpracujZelvicku;
    procedure zpracujDokud;
    procedure zpracujProvadej;
    procedure zpracujHodnota;
    procedure zpracujPravdivost;
    procedure zpracujNapis;
    function zpracujPrikaz (nazevPrikazu: String): boolean;
    function nactiPrikaz: boolean;
    procedure zpracujSkupinuPrikazu;
    procedure run (p: Procedura);
    procedure preberParametry;
    procedure napoveda;
    procedure spustProceduru (p: Procedura);
    procedure hlaseniParseException;
    procedure hlaseniODTCisloException;
    procedure hlaseniVarsException;
    procedure hlaseniRuntimeException;
    procedure pustProceduru (p: Procedura);
    function vyhodnotFunkciCtiDes (pripravitOkno: boolean): ODTCislo;
    function vyhodnotFunkciCtiCele (pripravitOkno: boolean): ODTCislo;
    procedure otevriVstupniOkno;
  protected
    procedure Execute; override;
  public
    constructor Create (spustenaProcedura: Procedura; pOutput: TZImage; pProcs: TStrings);
    destructor Destroy; override;
end; {of type ZpracovaniZdrojovehoKodu}


implementation


constructor ZpracovaniZdrojovehoKodu.Create (spustenaProcedura: Procedura; pOutput: TZImage; pProcs: TStrings);
begin
    inherited Create (true);
    spustProcedura := spustenaProcedura;
    output := pOutput;
    procs := pProcs;
    vrs := Vars.Create;
    zasob := Zasobniky.Create;
    FreeOnTerminate := true;
end;


destructor ZpracovaniZdrojovehoKodu.Destroy;
begin
    vrs.Destroy;
    zasob.Destroy;
    inherited Destroy;
end;


procedure ZpracovaniZdrojovehoKodu.preskocMezery;
{preskoci netisknutelne znaky a komentare}
begin
    with aktPozice do begin
        while (proc.cti (znak) in BILE) or (proc.cti (znak) = '{') do begin
            if proc.cti (znak) <> '{' then
                inc (znak)
            else begin
                while proc.cti (znak) <> '}' do inc (znak);
                inc (znak);
                if znak > proc.delka then raise ParseException.Create (UNEXPECTED_FILE_END);
            end; {of if}
        end; {of while}
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.prohledniSiSlovo: String;
{precte ze zdrojoveho kodu slovo na aktualni pozici, ale aktualni pozici
 nastavi opet na zacatek precteneho slova, prectene slovo vrati, neni-li
 na aktualni pozici zadne slovo, vrati prazdny retezec, slovem se rozumi
 posloupnost alfanumerickych znaku, z nichz prvnim neni cisice}
var vysledek: String;
begin
    vysledek := '';
    with aktPozice do begin
        if jeAlfa (proc.cti (znak)) then begin
            while jeAlfNum (proc.cti (znak)) do begin
                vysledek := vysledek + proc.cti (znak);
                inc (znak);
            end;
            znak := znak - length (vysledek);
        end; {of if}
    end; {of with}
    prohledniSiSlovo := vysledek;
end;


function ZpracovaniZdrojovehoKodu.cislo: ODTCislo;
{precte ze zdrojoveho kodu cislo pomoci Hornerova schematu, vysledek vrati}
const DESETINNA_CARKA = ',';
var celaCast: integer; {cela a desetinne cast se ctou v ruznych blocich procedury "cislo"}
var desetinnaCast: real; {desetinne cast se cte pouze v pripade, ze se narazi na desetinnou carku}
var desetinneMisto: real; {pomocna promenna slouzici pri cteni desetinne casti}
begin
    with aktPozice do begin
        if not jeNum (proc.cti (znak)) then
            raise ParseException.Create (NUMBER_EXPECTED); {cislo musi zacinat cislici, napr. ",63" neni platne cislo, nutno psat 0,63}
        celaCast := 0;
        while jeNum (proc.cti (znak)) do begin {Horner}
            celaCast := 10 * celaCast + ord (proc.cti (znak)) - ord ('0');
            inc (znak);
        end;
        if proc.cti (znak) = DESETINNA_CARKA then begin {ma ci nema des. cast?}
            inc (znak);
            desetinneMisto := 1;
            desetinnaCast := 0;
            while jeNum (proc.cti (znak)) do begin
                desetinneMisto := desetinneMisto / 10;
                desetinnaCast := desetinnaCast + desetinneMisto * (ord (proc.cti (znak)) - ord ('0'));
                inc (znak);
            end;
            cislo := ODTCislo.Create(celaCast + desetinnaCast);
            {zavola konstruktor, ktery vraci promennou ODTCislo s nastavenym typem CISLO_DESETINNE}
        end else cislo := ODTCislo.Create (celaCast); {a tady s typem CISLO_CELE}
    end; {of if}
end; {of cislo}


function ZpracovaniZdrojovehoKodu.promenna: ODTCislo;
{preskoci uvodni dolar, precte nazev promenne a jeji hodnotu zkopiruje a vrati}
var nazevProm: String;
begin
    inc (aktPozice.znak);
    nazevProm := ctiSlovo;
    promenna := ODTCislo.Create (ODTCislo (vrs.najdiPromennou (nazevProm)));
end;

{nasledujici funkce prectou ze zdrojaku aritmeticky vyraz, predaji tuto hodnotu
 funkci, kterou vyhodnocuji (sin/cos/ln/...) a vrati vysledek}


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciSin: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciSin := argument.fSin;
    finally {aby nedoslo k memory leaku}
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciCos: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciCos := argument.fCos;
    finally
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciLn: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciLn := argument.fLn;
    finally
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciLog: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciLog := argument.fLog;
    finally
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciCelacast: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciCelacast := argument.Truncated;
    finally
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciZaokrouhlene: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciZaokrouhlene := argument.Rounded;
    finally
        argument.Destroy;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciOdm: ODTCislo;
var argument: ODTCislo;
begin
    argument := vyraz;
    try
        vyhodnotFunkciOdm := argument.fSqrt;
    finally
        argument.Destroy;
    end;
end;


procedure ZpracovaniZdrojovehoKodu.pripravVstupniOkno;
{ze zdrojoveho kodu precte text v uvozovkach, ten zkopiruje coby popisek
 do okna, ktere bude pozdeji slouzit k nacteni promenne ciselneho typu
 u funkci ctiCele a ctiDes}
begin
    with aktPozice do begin
        Form8.Label1.Caption := '';
        preskocMezery;
        if proc.cti (znak) <> '"' then
                raise ParseException.Create (PRECTI_QUOTES_EXPECTED);
        inc (znak);
        while proc.cti (znak) <> '"' do begin
            Form8.Label1.Caption := Form8.Label1.Caption + proc.cti (znak);
            inc (znak);
        end;
        inc (znak);
    end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.otevriVstupniOkno;
begin
    odpovedModOkna := Form8.ShowModal;
end;



function ZpracovaniZdrojovehoKodu.vyhodnotFunkciCti (des: boolean): ODTCislo;
{Tato funkce je volana funkcemi vyhodnotFunkciCtiCele a vyhodnotFunkciCtiDes
 -- parametr des urcuje, jestli se ma nacist desetinne cislo (je-li) false,
 cte se cele. Funkce otevre okno, ve kterem se objevi vyzva, aby uzivatel
 zadal promennou daneho typu, zadana hodnota se vrati jako vysledek funkce.}
var zadano: boolean;
begin
    zadano := false;
    while not zadano do begin {cyklus bezi do doby, nez uzivatel zada validni hodnotu}
        Synchronize (otevriVstupniOkno);
        if odpovedModOkna = mrOK then
            try
                if des then vyhodnotFunkciCti := ODTCislo.Create (StrToFloat (Form8.Edit1.Text))
                else vyhodnotFunkciCti := ODTCislo.Create (StrToInt (Form8.Edit1.Text));
                zadano := true;
            except
                if des then ShowMessage ('Neplatn desetinn slo.')
                else ShowMessage ('Neplatn cel slo.');
            end
        else begin
            vyhodnotFunkciCti := ODTCislo.Create; {pokud uzivatel zavre vstupni okno, vrati funkce cislo 0}
            zadano := true;
        end; {of if}
    end; {of while}
end; {of vyhodnotFunkciCti}


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciCtiDes (pripravitOkno: boolean): ODTCislo;
{Je-li parametr pripravitOkno true, precte funkce z aktualni pozice ve
 zdrojovem kodu text v uvozovkach, ten vlozi coby popisek do vstupniho okna,
 do vstupniho okna zada uzivatel cele cislo, to se vrati coby vysledek funkce.
 Je-li parametr pripravitOkno false, popisek se nekopiruje, pouze se otevre okno
 a precte cele cislo}
begin
    if pripravitOkno then
        Synchronize (pripravVstupniOkno);
    vyhodnotFunkciCtiDes := vyhodnotFunkciCti (true);
end; {of vyhodnotFunkciCtiDes}


function ZpracovaniZdrojovehoKodu.vyhodnotFunkciCtiCele (pripravitOkno: boolean): ODTCislo;
{jako u minule funkce, ale ctene cislo je desetinne}
begin
    if pripravitOkno then
        Synchronize (pripravVstupniOkno);
    vyhodnotFunkciCtiCele := vyhodnotFunkciCti (false);
end; {of vyhodnotFunkciCtiCele}


procedure ZpracovaniZdrojovehoKodu.pripravLogOkno;
begin
    Form9.Label1.Caption := '';
    with aktPozice do begin
        preskocMezery;
        if proc.cti (znak) <> '"' then
            raise ParseException.Create (PRECTI_QUOTES_EXPECTED);
        inc (znak);
        while proc.cti (znak) <> '"' do begin
            Form9.Label1.Caption := Form9.Label1.Caption + proc.cti (znak);
            inc (znak);
        end; {of while}
        inc (znak);
        preskocMezery;
        odpovedModOkna := Form9.ShowModal;
    end; {of with}
end;



function ZpracovaniZdrojovehoKodu.vyhodnotFunkciOtazka: ODTLogickaHodnota;
{precte ze zdrojoveho kodu z aktualni pozice text v uvozovkach, ten zkopiruje
 coby popisek do vstupniho okna a ze vstupniho okna precte hodnotu
 ano/ne (true/false), tu vrati}
begin
    Synchronize (pripravLogOkno);
    if odpovedModOkna = mrYes then vyhodnotFunkciOtazka := ODTLogickaHodnota.Create (true)
                              else vyhodnotFunkciOtazka := ODTLogickaHodnota.Create (false);
end; {of vyhodnotFunkciOtazka}


function ZpracovaniZdrojovehoKodu.vyhodnotFunkci: ODTCislo;
{Precte z aktualni pozice nazev funkce, rozhodne, jesli to je funkce jedne
 promenne, pokud ne, doplni hodnotu E nebo PI, pokud ano, preskoci oteviraci
 zavorku, zavola funkci (Delphovskou), ktera vrati hodnotu prislusne
 funkce (matematicke), preskoci uzaviraci zavorku.}
var nazevFce: String;
begin
    nazevFce := ctiSlovo;
    if nazevFce = 'PI' then vyhodnotFunkci := ODTCislo.Create (PI)
    else if nazevFce = 'E' then vyhodnotFunkci := ODTCislo.Create (EULER)
    else begin {je to funkce 1 promenne}
        preskocMezery;
        if aktPozice.proc.cti (aktPozice.znak) <> '(' then
            raise ParseException.Create (OPENING_BRACKET_EXPECTED);
        inc (aktPozice.znak);
             if nazevFce = 'sin' then vyhodnotFunkci := vyhodnotFunkciSin
        else if nazevFce = 'cos' then vyhodnotFunkci := vyhodnotFunkciCos
        else if nazevFce = 'ln'  then vyhodnotFunkci := vyhodnotFunkciLn
        else if nazevFce = 'log' then vyhodnotFunkci := vyhodnotFunkciLog
        else if nazevFce = 'odm' then vyhodnotFunkci := vyhodnotFunkciOdm
        else if nazevFce = 'celacast' then vyhodnotFunkci := vyhodnotFunkciCelacast
        else if nazevFce = 'zaokrouhlene' then vyhodnotFunkci := vyhodnotFunkciZaokrouhlene
        else if nazevFce = 'ctides'   then vyhodnotFunkci := vyhodnotFunkciCtiDes (true)
        else if nazevFce = 'cticele'  then vyhodnotFunkci := vyhodnotFunkciCtiCele (true)
        else begin
            aktPozice.znak := aktPozice.znak - 2;
            raise ParseException.Create (UNKNOWN_FUNCTION);
        end;
        preskocMezery;
        if aktPozice.proc.cti (aktPozice.znak) <> ')' then
            raise ParseException.Create (CLOSING_BRACKET_EXPECTED);
        inc (aktPozice.znak);
    end; {of if}
end;


function ZpracovaniZdrojovehoKodu.faktorPozitivni: ODTCislo;
{faktorPozitivni je faktor bez unarniho plus ci minus, muze jim byt promenna,
 uzavorkovany podvyraz, funkce nebo samotne cislo}
begin
    with aktPozice do begin
        if proc.cti (znak) = '$' then
            faktorPozitivni := promenna
        else if proc.cti (znak) = '(' then begin
            inc (znak); {preskoceni zavorky}
            faktorPozitivni := vyraz;
            if proc.cti (znak) <> ')' then
                raise ParseException.Create (CLOSING_BRACKET_EXPECTED);
            inc (znak);
        end else if jeAlfa (proc.cti (znak)) then
            faktorPozitivni := vyhodnotFunkci
        else faktorPozitivni := cislo;
    end;
end;


function ZpracovaniZdrojovehoKodu.faktor: ODTCislo;
{obohacuje faktorPozitivni o unarni znamenka}
begin
    preskocMezery;
    with aktPozice do begin
        if proc.cti (znak) = '+' then begin
            inc (znak);
            faktor := faktorPozitivni;
        end else if proc.cti (znak) = '-' then begin
            inc (znak);
            faktor := faktorPozitivni;
            faktor.Negate
        end else faktor := faktorPozitivni;
    end;
    preskocMezery;
end;


function ZpracovaniZdrojovehoKodu.clen: ODTCislo;
var tmp: ODTCislo; {zvlastni promenna, aby sel objekt zrusit a nedoslo k memory leaku}
var ch: char;
begin
    with aktPozice do begin
        clen := faktor;
        preskocMezery;
        while (proc.cti (znak) = '*') or (proc.cti (znak) = '/') do begin
            ch := proc.cti (znak);
            inc (znak);
            tmp := faktor;
            if ch = '*' then clen.Multip (tmp)
                        else clen.DivideBy (tmp);
            preskocMezery;
            tmp.Destroy;
        end;
    end;
end;


function ZpracovaniZdrojovehoKodu.vyraz: ODTCislo;
var tmp: ODTCislo; {zvlastni promenna, aby sel objekt zrusit}
var ch: char;
begin
    with aktPozice do begin
        vyraz := clen;
        preskocMezery;
        while (proc.cti (znak) = '+') or (proc.cti (znak) = '-') do begin
            ch := proc.cti (znak);
            inc (znak);
            tmp := clen;
            if ch = '+' then vyraz.Add (tmp)
                        else vyraz.Subtr (tmp);
            preskocMezery;
            tmp.Destroy;
        end;
    end;
end;


function ZpracovaniZdrojovehoKodu.ctiZnamenko: String;
{mysli se tim znamenko porovnani: =, <, >, <=, >=}
const ZNAMENKOVE = ['=', '<', '>'];
var vysl: String;
begin
    with aktPozice do begin
        vysl := '';
        while proc.cti (znak) in ZNAMENKOVE do begin
            vysl := vysl + proc.cti (znak);
            inc (znak);
        end; {of while}
    end;
    ctiZnamenko := vysl;
end;


function ZpracovaniZdrojovehoKodu.compare (const vyr1, vyr2: ODTCislo; const znamenko: String): ODTLogickaHodnota;
{Vyhodnoti logicky vyraz tvaru <vyr1> <znamenko> <vyr2>, kde vyr1 a vyr2 jsou
 ciselne hodnoty a znamenko je operator porovnani. Vrati, jestli je vyraz pravdivy.}
begin
    if znamenko = '=' then
        compare := ODTLogickaHodnota.Create (vyr1.getReal = vyr2.getReal)
    else if znamenko = '<' then
        compare := ODTLogickaHodnota.Create (vyr1.getReal < vyr2.getReal)
    else if znamenko = '>' then
        compare := ODTLogickaHodnota.Create (vyr1.getReal > vyr2.getReal)
    else if znamenko = '<=' then
        compare := ODTLogickaHodnota.Create (vyr1.getReal <= vyr2.getReal)
    else if znamenko = '>=' then
        compare := ODTLogickaHodnota.Create (vyr1.getReal >= vyr2.getReal)
    else raise ParseException.Create (COMPARISON_SIGN_EXPECTED);
end;


function ZpracovaniZdrojovehoKodu.logickaHodnota: ODTLogickaHodnota;
{precte prvni vyraz, znamenko porovnani, druhy vyraz, tj. napr.: 2*2<=3*3,
 zavola funkci compare a tak zjisti, jestli je takova logicka hodnota pravdiva
 ci ne}
var vyr1, vyr2: ODTCislo;
var znamenko: String;
begin
    with aktPozice do begin
        vyr1 := vyraz;
        preskocMezery;
        znamenko := ctiZnamenko;
        preskocMezery;
        try
            vyr2 := vyraz;
            try
                logickaHodnota := compare (vyr1, vyr2, znamenko);
            finally
                vyr2.Destroy;
            end;
        finally
            vyr1.Destroy;
        end; {of try}
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.zpracujFunkciOtazka: ODTLogickaHodnota;
{precte oteviraci zavorku, zavola funkci, ktera se postara o zobrazeni okna
 pro nacteni logicke hodnoty, precte uzaviraci, log. hodnotu vrati}
begin
    with aktPozice do begin
        ctiSlovo;
        preskocMezery;
        if proc.cti (znak) <> '(' then
            raise ParseException.Create (OPENING_BRACKET_EXPECTED);
        inc (znak);
        zpracujFunkciOtazka := vyhodnotFunkciOtazka;
        if proc.cti (znak) <> ')' then
            raise ParseException.Create (CLOSING_BRACKET_EXPECTED);
        inc (znak);
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.zpracujFunkciNe: ODTLogickaHodnota;
{logicka funkce ne -- negace logickeho cinitele, ktery za ni nasleduje}
var tmp: ODTLogickaHodnota;
begin
    ctiSlovo;
    tmp := logickyCinitel;
    zpracujFunkciNe := tmp.negated;
    tmp.Destroy;
end;


function ZpracovaniZdrojovehoKodu.logickaPromenna (var vysledek: ODTLogickaHodnota): boolean;
{Overi, jestli promenna, ktera se nachazi na aktualni pozici, je logickeho typu,
pokud ano, zkopiruje jeji hodnotu do "vysledek" a vrati true. Jinak vrati false.}
var nazevPromenne: String;
var objektPromenne: ODT;
begin
    logickaPromenna := false;
    with aktPozice do begin
        if proc.cti (znak) = '$' then begin
            inc (znak);
            nazevPromenne := prohledniSiSlovo;
            objektPromenne := vrs.najdiPromennou (nazevPromenne);
            if objektPromenne is ODTLogickaHodnota then begin
                ctiSlovo;
                vysledek := ODTLogickaHodnota.Create
                    ((objektPromenne as ODTLogickaHodnota).value);
                logickaPromenna := true;
            end else dec (znak);
        end; {of if}
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.logickyCinitel: ODTLogickaHodnota;
{logickym cinitelem muze byt bud logicka promenna, uzavorkovany logicky
 podvyraz, logicka funkce (otazka -- zobrazeni ailogu ano/ne, ne -- negace),
 nebo logicka hodnota (napr. 3 >= 2)}
var nazevFunkce: String;
var vysledek: ODTLogickaHodnota;
begin
    preskocMezery;
    with aktPozice do begin
        if logickaPromenna (vysledek) then begin
            logickyCinitel := vysledek;
            exit;
        end;
        if proc.cti (znak) = '(' then begin
            inc (znak);
            logickyCinitel := logickyVyraz;
            if proc.cti (znak) <> ')' then
                raise ParseException.Create (CLOSING_BRACKET_EXPECTED);
            inc (znak);
        end else if jeAlfa (proc.cti (znak)) then begin
            nazevFunkce := prohledniSiSlovo;
            if nazevFunkce = 'otazka' then logickyCinitel := zpracujFunkciOtazka
            else if nazevFunkce = 'ne' then logickyCinitel := zpracujFunkciNe
            else if nazevFunkce = 'ANO' then
                begin ctiSlovo; logickyCinitel := ODTLogickaHodnota.Create (true); end
            else if nazevFunkce = 'NE' then
                begin ctiSlovo; logickyCinitel := ODTLogickaHodnota.Create (false); end
            else logickyCinitel := logickaHodnota;
        end else logickyCinitel := logickaHodnota;
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.logickyScitanec: ODTLogickaHodnota;
{Logicky scitanec je takovy logicky vyraz, ktery obsahuje logicke hodnoty,
 operatory negace a konjunkce (a).}
var vysledek, tmp: ODTLogickaHodnota;
begin
    vysledek := logickyCinitel;
    preskocMezery;
    while prohledniSiSlovo = 'a' do begin
        ctiSlovo;
        tmp := logickyCinitel;
        vysledek.conjunction (tmp);
        tmp.Destroy;
        preskocMezery;
    end; {of while}
    logickyScitanec := vysledek;
end;


function ZpracovaniZdrojovehoKodu.logickyVyraz: ODTLogickaHodnota;
{precte logicky vyraz ze zdrojoveho kodu se vsim vsudy (a/nebo/ne/<>=/...)
 a vrati jeho hodnotu}
var vysledek, tmp: ODTLogickaHodnota;
begin
    vysledek := logickyScitanec;
    preskocMezery;
    while prohledniSiSlovo = 'nebo' do begin {log. vyraz je rozsirenim log. scitance o operator "nebo"}
        ctiSlovo;
        tmp := logickyScitanec;
        vysledek.disjunction (tmp);
        tmp.Destroy;
        preskocMezery;
    end; {of while}
    logickyVyraz := vysledek;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujVpred;
{prikaz vpred o ... -- posunuti zelvicky o zadanou hodnotu vpred}
var d: real;
begin
    with aktPozice do begin
        preskocMezery;
        if proc.cti(znak) <> 'o' then
            raise ParseException.Create(VPRED_O_MISSING);
        inc (znak);
        d := vyraz.getReal;
        output.vpred(d);
    end;
end;


function ZpracovaniZdrojovehoKodu.ctiSlovo: String;
{slovem se rozumi posloupnost alfanumerickych znaku, funkce je precte ze zdrojoveho kodu}
var vysl: String;
begin
    vysl := '';
    with aktPozice do
        while jeAlfNum (proc.cti(znak)) do begin
            vysl := vysl + proc.cti(znak);
            inc (znak);
        end;
    ctiSlovo := vysl;
end;


procedure ZpracovaniZdrojovehoKodu.doctiZaZnak (ch: char);
{od aktualni pozice cte tak dlouho, nez narazi na znak ch, ignoruje
 vnitrky komentaru a uvozovek}
begin
    with aktPozice do begin
      while (true) do begin
        if proc.cti (znak) = ch then begin
            inc (znak);
            break;
        end else if proc.cti (znak) = '{' then begin
            while proc.cti (znak) <> '}' do inc (znak);
            inc (znak);
        end else if proc.cti (znak) = '"' then begin
            while proc.cti (znak) <> '"' do inc (znak);
            inc (znak);
        end else inc (znak);
      end; {of while}
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.doctiZa: konPrikaz;
{Slouzi k preskoceni kusu kodu, ktery se nachazi mezi parovymi prikazy
 ci prikazy pro blokove konstrukce (nebo pokud, jinak, konec).
 Funkce je volana tehdy, kdyz aktualni pozice ve zdrojovem kodu se nachazi
 bezprostredne za prvnim z parovych prikazu (pokud, opakuj, pocitej,...).
 Funkce najde odpovidajici prikaz ukoncujici jednu cast bloku
 (nebo pokud, konec, jinak), za nim (pred strednikem) se zastavi a vrati,
 za kterym  prikazem se zastavila.}
var prikaz: String;
var zanoreni: integer;
begin
    zanoreni := 0; {aby nasel odpovidajici blokovy prikaz, musi ignorovat prikazy patrici k vnorenym blokum}
    with aktPozice do
    while (true) do begin
        preskocMezery;
        prikaz := ctiSlovo;
        if (prikaz = 'opakuj') or (prikaz = 'pocitej') or (prikaz = 'pokud') then begin
            inc (zanoreni);
            doctiZaZnak (':');
        end else if prikaz = 'jinak' then begin
            if zanoreni = 0 then begin doctiZa := kpJINAK; exit; end;
            doctiZaZnak (':');
        end else if prikaz = 'nebo' then begin
            if zanoreni = 0 then begin doctiZa := kpNEBO; exit; end;
            doctiZaZnak (':');
        end else if prikaz = 'konec' then begin
            if zanoreni = 0 then begin doctiZa := kpKONEC; exit; end;
            doctiZaZnak (';');
            dec (zanoreni);
        end else
            doctiZaZnak (';');
    end; {of while}
    doctiZa := kpError;
end; {of doctiZa}


procedure ZpracovaniZdrojovehoKodu.zpracujOtoc;
{prikaz otoc o... -- otoceni zelvicky o zadany pocet stupnu po smeru hod. rucicek}
var fi: real;
var smer: String;
var tmp: ODTCislo;
begin
    with aktPozice do begin
        preskocMezery;
        if proc.cti(znak) <> 'o' then
            raise ParseException.Create(OTOC_O_MISSING);
        inc (znak);
        tmp := vyraz;
        fi := (tmp.getReal / 180) * PI;
        tmp.Destroy;
        preskocMezery;
        if proc.cti (znak) <> ';' then begin
            smer := ctiSlovo;
            if smer = 'doprava' then
            else if smer = 'doleva' then fi := -fi
            else raise ParseException (OTOC_UNKNOWN_DIRECTION);
        end;
        output.otoc(fi);
    end;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujVymazat;
{prikaz smaz! -- smazani obrazovky}
begin
    with aktPozice do begin
        if proc.cti (znak) <> '!' then
            raise ParseException.Create (SMAZ_EXCL_MISSING);
        inc (znak);
    end;
    output.vymazat;
end;


{nasleduje zpracovani prikazu, ktere meni parametry pera}


procedure ZpracovaniZdrojovehoKodu.zpracujZvedni;
begin
    output.zvedniPero;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujPoloz;
begin
    output.polozPero;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujTloustka;
var tloustka: ODTCislo;
begin
    preskocMezery;
    if ctiSlovo <> 'bud' then
        raise ParseException.Create (TLOUSTKA_BUD_EXPECTED);
    preskocMezery;
    tloustka := vyraz;
    if not tloustka.jeCele then
        raise ParseException.Create (TLOUSTKA_NOT_INTEGER);
    output.sirkaPera (tloustka.getInteger);
end;


procedure ZpracovaniZdrojovehoKodu.zpracujBarva;
var barva: String;
begin
    preskocMezery;
    if ctiSlovo <> 'bud' then
        raise ParseException.Create (TLOUSTKA_BUD_EXPECTED);
    preskocMezery;
    barva := ctiSlovo;
    output.barvaPera (barva)
end;


procedure ZpracovaniZdrojovehoKodu.vykonejOpakuj (n: integer);
{je volana procedurou zpracujOpakuj, pri zavolani se nachazi bezprostredne
 za dvojteckou prikazu "opakuj", n krat provede blok prikazu}
var zacatek, i: integer;
begin
    with aktPozice do begin
        if n <= 0 then begin {pro n <= 0 se neprovede vubec, blok se preskoci az po odpovidajici prikaz "konec"}
            if doctiZa <> kpKonec then raise ParseException (OPAKUJ_KONEC_MISSING);
        end else begin
            zacatek := znak; {zapamatujeme si, abychom vedeli, kam se vratit na zacatku pristi iterace}
            for i := 1 to n do begin
                znak := zacatek;
                zpracujSkupinuPrikazu;
                if ctiSlovo <> 'konec' then
                    raise ParseException.Create (OPAKUJ_KONEC_MISSING);
            end; {of for}
        end; {of if}
    end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujOpakuj;
{Prikaz opakuj ... krat: -- provede n iteraci daneho bloku. Tato procedura
 nacte parametry prikazu "opakuj" a provede jej tak, ze zavola vykonejOpakuj}
var n: integer;
var tmp: ODTCislo;
begin
  with aktPozice do begin
    preskocMezery;
    tmp := vyraz;
    n := tmp.getInteger;
    tmp.Destroy;
    preskocMezery;
    if ctiSlovo <> 'krat' then
        raise ParseException.Create (OPAKUJ_KRAT_MISSING);
    preskocMezery;
    if proc.cti (znak) <> ':' then
        raise ParseException.Create (OPAKUJ_COLON_MISSING);
    inc (znak);
    vykonejOpakuj (n);
  end; {of with}
end;


function ZpracovaniZdrojovehoKodu.nactiJmenoPromenne: String;
{preskoci dolar z precte nazev, ten vrati.}
begin
    with aktPozice do begin
      preskocMezery;
      if proc.cti (znak) <> '$' then
          raise ParseException.Create (VAR_EXPECTED);
      inc (znak);
      nactiJmenoPromenne := ctiSlovo;
      preskocMezery;
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.ctiOdDoPo (co: String): integer;
{Funkce slouzi k nacteni parametru blokoveho prikazu pocitej ... od ... do ... po}
var tmp: ODTCislo;
begin
    if ctiSlovo <> co then begin
        if co = 'od' then
            raise ParseException.Create (POCITEJ_OD_EXPECTED)
        else if co = 'do' then
            raise ParseException.Create (POCITEJ_DO_EXPECTED)
        else if co = 'po' then
            raise ParseException.Create (POCITEJ_PO_EXPECTED);
    end;
    tmp := vyraz;
    if not tmp.jeCele then begin
        tmp.Destroy;
        raise ParseException.Create (POCITEJ_INTEGER_EXPECTED);
    end;
    ctiOdDoPo := tmp.getInteger;
    tmp.Destroy;
    preskocMezery;
end;


procedure ZpracovaniZdrojovehoKodu.vykonejPocitej (a, b, d: integer; const jmenoPromenne: String);
{Iteruje blok prikazu od aktualni pozice az po odpovidajici prikaz "konec",
 pri tom v kazdem pruchodu cyklem nastavi hodnotu promenne se jmenem
 <jmenoPromenne> na jinou hodnotu; zacina na hodnote a, v kazdem pruchodu
 ji zvysi o d, cyklus konci, jakmile hodnota presashne b}
var i, zacatek: integer;
begin
    if d = 0 then raise ParseException.Create (POCITEJ_ZERO_STEP);
    if ((a > b) and (d > 0)) or ((a < b) and (d < 0)) then begin {v tomto pripade se cyklus nema vykonat ani jednou, blok se ma tedy preskocit}
        if doctiZa <> kpKONEC then raise ParseException.Create (POCITEJ_KONEC_MISSING);
    end else begin
        zacatek := aktPozice.znak;
        i := a;
        while ((d > 0) and (i <= b)) or ((d < 0) and (i >= b)) do begin
            aktPozice.znak := zacatek;
            ODTCislo (vrs.najdiPromennou(jmenoPromenne)).Read (i);
            zpracujSkupinuPrikazu;
            i := i + d;
        end; {of while}
        if ctiSlovo <> 'konec' then
            raise ParseException.Create (POCITEJ_KONEC_MISSING);
    end;
end; {of vykonejPocitej}


procedure ZpracovaniZdrojovehoKodu.zpracujPocitej;
{zpracuje prikaz pocetej ... od ... do ... po ... -- nejprve nacte parametry
 prikazu pomoci ctiOdDoPo, pak prikaz vykona zavolanim vykonejPocitej}
var jmenoPromenne: String;
var a, b, d: integer;
begin
  with aktPozice do begin
    jmenoPromenne := nactiJmenoPromenne;
    a := ctiOdDoPo ('od');
    b := ctiOdDoPo ('do');
    d := 1;
    if proc.cti (znak) <> ':' then
        d := ctiOdDoPo ('po');
    preskocMezery;
    if proc.cti (znak) <> ':' then
        raise ParseException.Create (POCITEJ_COLON_EXPECTED);
    inc (znak);
    vykonejPocitej (a, b, d, jmenoPromenne);
  end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.zavolejProceduru (p: TObject);
{aktualni pozici ulozi na callStack, novou pozici nastavi na zacatek
 kyzene procedury, hodi parametry na paramStack, vykona volanou proceduru,
 pak nastavi puvodni pozici}
var i: integer;
var pODT: ODT;
var proc: Procedura;
begin
    proc := Procedura (p); {konverze}
    preskocMezery;
    for i := 1 to proc.parametru do begin
        if  proc.parametry[i].typ = LOGICKA_HODNOTA then begin
            pODT := logickyVyraz;
        end else if proc.parametry[i].typ = CISLO_CELE then begin
            pODT := vyraz;
            if not (pODT as ODTCislo).jeCele then
                raise ODTCisloException.Create (LOSS_OF_PRECISION);
        end else if proc.parametry[i].typ = CISLO_DESETINNE then begin
            pODT := vyraz;
        end; {of if}
        preskocMezery;
        zasob.newParam (pODT);
    end; {of for}
    with aktPozice do
        zasob.newCall (proc, znak);
    run (proc);
    aktPozice := zasob.popCall;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujPokudTrue;
{Je volana tehdy, kdyz se pri zpracovavani bloku "pokud" narazi na tu vetev,
 ktera ma byt vykonana. Vetev se tedy vykona, pokud se na konci vetve
 nachazeji prikazy "nebo" ci "jinak", preskoci se vsechny casti bloku az po
 odpovidajici "konec". Pokud "konec" chybi, je to chyba.}
var slovo: String;
begin
    with aktPozice do begin
        zpracujSkupinuPrikazu;
        slovo := ctiSlovo;
        if (slovo = 'nebo') or (slovo = 'jinak') then begin
            while proc.cti (znak) <> ':' do inc (znak);
            inc (znak);
            while doctiZa <> kpKonec do begin
                while proc.cti (znak) <> ':' do inc (znak);
                inc (znak);
            end;
        end else if slovo <> 'konec' then
            raise ParseException.Create (POKUD_INVALID_CONSTRUCTION);
    end; {of with}
end;


function ZpracovaniZdrojovehoKodu.zpracujPokudFalse: boolean;
{Pousti se tehdy, jestlize se pri zpracovavani bloku "pokud" narazi na vetev,
 ktera ma byt preskocena. V tom pripade procedura vetev preskoci. Jestlize na
 konci vetve narazi na blok "jinak", okamzite jej zpracuje. Jestlize narazi
 na blok "nebo pokud", nastavi aktualni pozici na zacatek logickeho vyrazu
 (tim pripravi pudu pro dalsi zpracovani). Funkce vraci true, pokud
 je blok "pokud" zcela zpracovan.}
var navesti: konPrikaz;
begin
    zpracujPokudFalse := false;
    with aktPozice do begin
        navesti := doctiZa; {navesti nam rika, jakym prikazem je vetev ukoncena (konec/nebo/jinak)}
        if navesti = kpKonec then zpracujPokudFalse := true {ukonci zpracovavani bloku "pokud"}
        else if navesti = kpJinak then begin {tuto vetev okamzite zpracuje}
            preskocMezery;
            if proc.cti (znak) <> ':' then raise ParseException.Create (POKUD_COLON_EXPECTED);
            inc (znak);
            zpracujSkupinuPrikazu;
            preskocMezery;
            if ctiSlovo <> 'konec' then raise ParseException.Create (POKUD_KONEC_EXPECTED);
            zpracujPokudFalse := true; {vetev "jinak" byla zpracovana}
        end else if navesti = kpNebo then begin
            preskocMezery;
            if ctiSlovo <> 'pokud' then raise ParseException.Create (POKUD_POKUD_EXPECTED);
            preskocMezery;
        end else raise ParseException.Create (POKUD_INVALID_CONSTRUCTION);
    end; {of with aktPozice}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujPokud;
{Precte parametry prikazu pokud a pak prochazi jednotli ve casti bloku "pokud",
 dokud nenarazi na tu, ktera byla zpracovana.}
var zpracovano, hodnotaLV: boolean;
var tmp: ODTLogickaHodnota;
begin
    with aktPozice do begin
        zpracovano := false; {rika, jestli uz byla zpracovana nektera z vetvi konstrukce "pokud"}
        while not zpracovano do begin
            preskocMezery;
            tmp := logickyVyraz;
            hodnotaLV := tmp.value;
            tmp.Destroy;
            preskocMezery; {logicka hodnota nactena, jde se dal}
            if proc.cti (znak) <> ':' then raise ParseException.Create (POKUD_COLON_EXPECTED);
            inc (znak);
            if hodnotaLV then begin
                zpracujPokudTrue; {procedura zpracujPokudTrue vykona prikazy zapsane bezprostredne za prave nactenym radkem}
                zpracovano := true; {hotovo, muze se vyskocit z cyklu}
            end else begin
                zpracovano := zpracujPokudFalse; {procedura zpracujPokudFalse tyto prikazy preskoci, pricemz pokud pote narazi na vetev "jinak", provede ji => vrati true}
            end; {of if hodnotaLV}
        end; {of while not zpracovano}
    end; {of with aktPozice}
end;


procedure ZpracovaniZdrojovehoKodu.prirad (const jmenoPromenne: String);
{Do promenne daneho nazvu prirazi hodnotu vyrazu, ktery se nachazi
 ve zdrojovem kodu na aktualni pozici.}
var pLogicky: ODTLogickaHodnota;
var pCislo: ODTCislo;
var objektPromenne: ODT;
begin
    inc (aktPozice.znak);
    preskocMezery;
    objektPromenne := vrs.najdiPromennou (jmenoPromenne);
    if objektPromenne.getType = LOGICKA_HODNOTA then begin
        pLogicky := logickyVyraz;
        (objektPromenne as ODTLogickaHodnota).Read (pLogicky);
        pLogicky.Destroy;
    end else if objektPromenne.getType = CISLO_CELE then begin
        pCislo := vyraz;
        (objektPromenne as ODTCislo).Read (pCislo);
        pCislo.Destroy;
    end else if objektPromenne.getType = CISLO_DESETINNE then begin
        pCislo := vyraz;
        (objektPromenne as ODTCislo).Read (pCislo);
        pCislo.Destroy;
    end else raise MiscException (UNSPECIFIED_ERROR);
end;


procedure ZpracovaniZdrojovehoKodu.vytvorPromennou (const jmenoPromenne: String);
{Implementuje prikaz "at" se syntaxi "at $promenna je cele/logicka/desetinna".
 Pri zavolani se nachazi pred slovem "je". Prikaz vytvori promennou
 daneho jmena a prislusneho typu.}
var tmp: String;
var promenna: ODT;
begin
    if ctiSlovo <> 'je' then
        raise ParseException.Create (AT_JE_EXPECTED);
    preskocMezery;
    tmp := ctiSlovo;
         if tmp = 'cele' then  promenna := ODTCislo.Create (false)
    else if tmp = 'logicka' then promenna := ODTLogickaHodnota.Create (false)
    else if tmp = 'desetinne' then promenna := ODTCislo.Create (true)
    else raise ParseException.Create (UNKNOWN_TYPE);
    vrs.pridejPromennou(jmenoPromenne, promenna);
end;


procedure ZpracovaniZdrojovehoKodu.inicializujPromennou;
{Implementuje prikaz "at" se syntaxi "at cele/logicka/deseinne $promenna = <vyraz>".
 Nejprve si zjisti typ promenne, pak ji vytvori, pak si zjisti jeji jmeno
 a pod timto jmenem ji ulozi pomoci vrs.pridejPromennou. Zaroven do ni ulozi
 hodnotu vyrazu, ktery se ve zdrojaku nachazi za rovnitkem.}
var tmp: String;
var promenna: ODT;
var jmenoPromenne: String;
begin
    tmp := ctiSlovo;
         if tmp = 'cele' then promenna := ODTCislo.Create (false)
    else if tmp = 'logicka' then promenna := ODTLogickaHodnota.Create (false)
    else if tmp = 'desetinne' then promenna := ODTCislo.Create (true)
    else raise ParseException.Create (UNKNOWN_TYPE);
    preskocMezery;
    jmenoPromenne := nactiJmenoPromenne;
    vrs.pridejPromennou (jmenoPromenne, promenna);
    preskocMezery;
    if aktPozice.proc.cti (aktPozice.znak) <> '=' then
        raise ParseException.Create (AT_EQUALS_EXPECTED);
    prirad (jmenoPromenne);
end;


procedure ZpracovaniZdrojovehoKodu.zpracujAt;
{Rozlisi tri mozne zpusoby pouziti prikazu "at" a dle toho zavola prislusnou
 proceduru.}
var jmenoPromenne: String;
begin
    preskocMezery;
    with aktPozice do begin
        if proc.cti (znak) = '$' then begin
            inc (znak);
            jmenoPromenne := ctiSlovo;
            preskocMezery;
            if proc.cti (znak) = '=' then prirad (jmenoPromenne)
                                     else vytvorPromennou (jmenoPromenne);
        end else inicializujPromennou;
    end; {of with aktPozice}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujZelvicku;
{prikazy "zelvicku ukaz" a "zelvicku skryj"}
var ukon: String;
begin
    preskocMezery;
    ukon := ctiSlovo;
          if ukon = 'ukaz'  then output.kresliZelvicku
    else  if ukon = 'skryj' then output.nekresliZelvicku
    else raise ParseException.Create (ZELVICKU_UNKNOWN_ACTION); 
end;


procedure ZpracovaniZdrojovehoKodu.zpracujDokud;
{Zpracovani blokoveho prikazu "dokud". Zapamatujeme si zacatek bloku
 (coz je misto tesne pred logickym vyrazem), v kazdem pruchodu pak logicky
 v kazdem pruchodu pak log. vyraz vyhodnotime, je-li pravdivy, zpracujeme
 skupinu prikazu az po "konec", je-li nepravdivy, preskocime prikazy po "konec"
 a ukoncime cyklus.}
var opakovat, hodnotaLV: boolean;
var tmp: ODTLogickaHodnota;
var zacatek: integer;
begin
    opakovat := true;
    with aktPozice do begin
        zacatek := znak;
        while (opakovat) do begin
            znak := zacatek;
            tmp := logickyVyraz;
            hodnotaLV := tmp.value;
            tmp.Destroy;
            preskocMezery;
            if proc.cti (znak) <> ':' then raise ParseException.Create (DOKUD_COLON_EXPECTED);
            inc (znak);
            if not hodnotaLV then begin
                opakovat := false;
                if doctiZa <> kpKonec then raise ParseException.Create (DOKUD_KONEC_EXPECTED);
            end else begin
                zpracujSkupinuPrikazu;
                if ctiSlovo <> 'konec' then raise ParseException.Create (DOKUD_KONEC_EXPECTED);
            end; {of if}
        end; {of while}
    end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujProvadej;
{prikaz provadej -- obdoba repeat ... until -- Zpracujeme skupinu prikazu,
 na jejim konci je prikaz "nez <log. vyraz>", ten se vyhodnoti, je-li pravdivy,
 vracime se na zacatek, jinak cyklus ukoncime.}
var zakonceni: String;
var tmp: ODTLogickaHodnota;
var hodnotaLV: boolean;
var zacatek: integer;
begin
    preskocMezery;
    with aktPozice do begin
        if proc.cti (znak) <> ':' then
            raise ParseException.Create (PROVADEJ_COLON_EXPECTED);
        inc (znak);
        zacatek := znak;
        while true do begin
            zpracujSkupinuPrikazu;
            zakonceni := ctiSlovo;
            if zakonceni <> 'nez' then
                raise ParseException.Create (PROVADEJ_NEZ_EXPECTED);
            tmp := logickyVyraz;
            hodnotaLV := tmp.value;
            tmp.Destroy;
            if hodnotaLV then exit
                         else znak := zacatek;
        end; {of while}
    end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujHodnota;
{prikaz hodnota -- vytiskne hodnotu promenne cisleneho typu}
var tmp: ODTCislo;
begin
    preskocMezery;
    tmp := vyraz;
    if tmp.jeCele then
        ShowMessage (IntToStr (tmp.getInteger))
    else
        ShowMessage (FloatToStr (tmp.getReal));
    tmp.Destroy;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujPravdivost;
{prikaz pravdivost -- vytiskne hodnotu logicke promenne}
var tmp: ODTLogickaHodnota;
begin
    preskocMezery;
    tmp := logickyVyraz;
    if (tmp.value) then ShowMessage ('ano')
                   else ShowMessage ('ne');
    tmp.Destroy;
end;


procedure ZpracovaniZdrojovehoKodu.zpracujNapis;
{prikaz napis -- zobrazi okno s textem, ktery si precte z uvozovek,
 v nem nahradi vsechny promenne jejich hodnotami}
var vyslednyString: String;
var tmp: ODTCislo;
begin
    with aktPozice do begin
        vyslednyString := ''; {to, co se zobrazi v okne}
        preskocMezery;
        if proc.cti (znak) <> '"' then
            raise ParseException.Create (NAPIS_QUOTES_EXPECTED);
        inc (znak);
        while (true) do begin
            if proc.cti (znak)  = '"' then begin {uzaviraci uvozovka, ukonci cteni stringu}
                inc (znak);
                break;
            end else if proc.cti (znak) = '$' then begin {znaci zacatek promenne, misto nazvu se do vysledneho stringu kopiruje hodnota}
                tmp := promenna;
                vyslednyString := vyslednyString + FloatToStr (tmp.getReal);
                tmp.Destroy;
            end else begin
                vyslednyString := vyslednyString + proc.cti (znak); {jakykoliv jiny znak -- proste zkopiruje}
                inc (znak);
            end; {of if}
        end; {of while}
        ShowMessage (vyslednyString);
    end; {with}
end;


function ZpracovaniZdrojovehoKodu.zpracujPrikaz (nazevPrikazu: String): boolean;
{Funkci se preda nazev prikazu a ona na jeho zaklade zavola prislusnou
 proceduru. Vraci false, pokud je prikaz neznamy.}
var index: integer;
begin
    zpracujPrikaz := true;
         if nazevPrikazu = 'vpred'    then Synchronize (zpracujVpred)
    else if nazevPrikazu = 'otoc'     then Synchronize (zpracujOtoc)
    else if nazevPrikazu = 'smaz'     then Synchronize (zpracujVymazat)
    else if nazevPrikazu = 'opakuj'   then zpracujOpakuj
    else if nazevPrikazu = 'pokud'    then zpracujPokud
    else if nazevPrikazu = 'zvedni'   then Synchronize (zpracujZvedni)
    else if nazevPrikazu = 'poloz'    then Synchronize (zpracujPoloz)
    else if nazevPrikazu = 'tloustka' then Synchronize (zpracujTloustka)
    else if nazevPrikazu = 'barva'    then Synchronize (zpracujBarva)
    else if nazevPrikazu = 'at'       then zpracujAt
    else if nazevPrikazu = 'pocitej'  then zpracujPocitej
    else if nazevPrikazu = 'zelvicku' then Synchronize (zpracujZelvicku)
    else if nazevPrikazu = 'dokud'    then zpracujDokud
    else if nazevPrikazu = 'provadej' then zpracujProvadej
    else if nazevPrikazu = 'hodnota'  then Synchronize (zpracujHodnota)
    else if nazevPrikazu = 'pravdivost'  then zpracujPravdivost
    else if nazevPrikazu = 'napis'    then Synchronize (zpracujNapis)
    else begin
        index := procs.IndexOf(nazevPrikazu);
        if index >= 0 then zavolejProceduru (procs.Objects[index])
        else begin
            aktPozice.znak := aktPozice.znak - length (nazevPrikazu);
            zpracujPrikaz := false;
        end;
    end;
end;


function ZpracovaniZdrojovehoKodu.nactiPrikaz: boolean;
{Precte prikaz a jeho jmeno preda procedure zpracujPrikaz. Pak jeste overi,
 jestli je prikaz ukoncen povinnym strednikem. Vraci false,
 je-li prikaz neznamy.}
var nazevPrikazu: String;
begin
    if Terminated then
        raise Exception.Create ('Provdn procedury bylo zastaveno uivatelem.');
    nactiPrikaz := true;
    nazevPrikazu := '';
    preskocMezery;
    with aktPozice do begin
        while jeAlfNum (proc.cti(znak)) do begin
            nazevPrikazu := nazevPrikazu + proc.cti(znak);
            inc (znak);
        end;
        if zpracujPrikaz (nazevPrikazu) then begin
            preskocMezery;
            if proc.cti (znak) <> ';' then
                raise ParseException.Create(SEMICOLON_MISSING);
            inc (znak);
            preskocMezery;
        end else nactiPrikaz := false;
    end; {of with}
end;


procedure ZpracovaniZdrojovehoKodu.zpracujSkupinuPrikazu;
{Zpracovava prikazy, dokud nenarazi na nejaky neznamy.}
begin
    with aktPozice do
        while (znak <= proc.delka) and nactiPrikaz do;
end;


procedure ZpracovaniZdrojovehoKodu.run (p: Procedura);
var i: integer;
begin
    aktPozice.proc := p;
    aktPozice.znak := 1;
    vrs.zvysVysku; {nova uroven zasobniku promennych -- stare promenne budou prekryty nove definovanymi}
    for i := aktPozice.proc.parametru downto 1 do begin
        vrs.pridejPromennou (aktPozice.proc.parametry[i].nazev, zasob.popParam);
    end;
    zpracujSkupinuPrikazu;
    if aktPozice.znak < aktPozice.proc.delka then
        raise ParseException.Create (UNKNOWN_COMMAND);
    vrs.snizVysku;
end;


procedure ZpracovaniZdrojovehoKodu.Execute;
begin
    pustProceduru (spustProcedura);
end;


procedure ZpracovaniZdrojovehoKodu.preberParametry;
var i: integer;
var typString: String;
var pODTCislo: ODT;
var p: Procedura;
begin
    p := proceduraPrebirajiciParametry; {cteni z GLOBALNI}
    for i := 1 to p.parametru do begin
        if p.parametry[i].typ = CISLO_CELE then
            typString := 'cel slo'
        else if p.parametry[i].typ = CISLO_DESETINNE then
            typString := 'desetinn slo';
        Form8.Label1.Caption := concat ('Tato procedura vyaduje parametr',
                                        ' s nzvem "$',
                                        p.parametry[i].nazev,
                                        '", kter m bt typu ',
                                        typString,
                                        '.');
        if p.parametry[i].typ = CISLO_CELE then
            pODTCislo := vyhodnotFunkciCtiCele (false)
        else if p.parametry[i].typ = CISLO_DESETINNE then
            pODTCislo := vyhodnotFunkciCtiDes (false)
        else if p.parametry[i].typ = LOGICKA_HODNOTA then begin
            Form9.Label1.Caption := 'Zvolte hodnotu logick promnn s nzvem $' + p.parametry[i].nazev;
            if Form9.ShowModal = mrYes then pODTCislo := ODTLogickaHodnota.Create (true)
                                       else pODTCislo := ODTLogickaHodnota.Create (false);
        end else
            raise MiscException (UNSPECIFIED_ERROR);
        zasob.newParam (pODTCislo);
    end; {of for}
end;


procedure ZpracovaniZdrojovehoKodu.napoveda;
begin
    with aktPozice do begin
        proc.Show (znak);
    end;
end;


procedure ZpracovaniZdrojovehoKodu.spustProceduru (p: Procedura);
begin
    proceduraPrebirajiciParametry := p; {GLOBALNI}
    Synchronize (preberParametry);
    run (p);
end;


procedure ZpracovaniZdrojovehoKodu.hlaseniParseException;
begin
    case ParseException (aktE).errType of
        SEMICOLON_MISSING: ShowMessage ('Na tomto mst ti chyb stednk.');
        VPRED_O_MISSING: ShowMessage ('Sprvn se pe "vpred o ...".');
        OTOC_O_MISSING: ShowMessage ('Sprvn se pe "otoc o ...".');
        SMAZ_EXCL_MISSING: ShowMessage ('Za pkazem "smaz" mus napsat vykink.');
        OPAKUJ_KRAT_MISSING: ShowMessage ('Sprvn se pe "opakuj ... krat:". Chyb ti slvko "krat".');
        OPAKUJ_COLON_MISSING: ShowMessage ('Sprvn se pe "opakuj ... krat:". Chyb ti dvojteka na konci.');
        OPAKUJ_KONEC_MISSING: ShowMessage ('Blok "opakuj" m bt zakonen pkazem "konec", ale j jej nikde nevidm.');
        POKUD_KONEC_EXPECTED: ShowMessage ('Tlo pkazu "pokud" je nesprvn ukoneno. Oekval jsem pkaz "konec".');
        POKUD_INVALID_CONSTRUCTION: ShowMessage ('Tlo pkazu "pokud" je nesprvn. Oekval jsem pkaz "konec", "nebo", nebo pkaz "jinak".');
        NUMBER_EXPECTED: ShowMessage ('Chyba, tady jsem oekval slo.');
        TLOUSTKA_BUD_EXPECTED: ShowMessage ('Sprvn se pe "tloustka bud ...". Chyb ti slvko "bud".');
        TLOUSTKA_NOT_INTEGER: ShowMessage ('Parametrem pkazu "tloustka" mus bt cel slo.');
        UNKNOWN_COLOR: ShowMessage ('Je mi lto, ale takovouto barvu neznm.');
        AT_JE_EXPECTED: ShowMessage ('Na tomto mst jsem oekval slovko "je".');
        AT_VARNAME_EXPECTED: ShowMessage ('Na tomto mst jsem oekval nsev promnn.');
        AT_EQUALS_EXPECTED: ShowMessage ('Na tomto mst jsem oekval rovntko.');
        VAR_EXPECTED: ShowMessage ('Na tomto mst jsem oekval nzev promnn.');
        POCITEJ_OD_EXPECTED: ShowMessage ('Na tomto mst jsem oekval slovo "od".');
        POCITEJ_DO_EXPECTED: ShowMessage ('Na tomto mst jsem oekval slovo "do".');
        POCITEJ_PO_EXPECTED: ShowMessage ('Na tomto mst jsem oekval slovo "po".');
        POCITEJ_COLON_EXPECTED: ShowMessage ('Na tomto mst jsem oekval dvojteku.');
        POCITEJ_KONEC_MISSING: ShowMessage ('Blok "pocitej" m bt zakonen pkazem "konec", ale j jej nikde nevidm.');
        POCITEJ_INTEGER_EXPECTED: ShowMessage ('Na tomto mst m bt cel slo.');
        POCITEJ_ZERO_STEP: ShowMessage ('V pkaze "pocitej" nelze napsat za slovem "po" nulu. Nedvalo by to smysl.');
        UNKNOWN_TYPE: ShowMessage ('Neznm typ promnn.');
        UNKNOWN_COMMAND: ShowMessage ('Neznm pkaz.');
        OTOC_UNKNOWN_DIRECTION: ShowMessage ('Tady jsem oekval, e nape "doleva" nebo "doprava".');
        POKUD_COLON_EXPECTED: ShowMessage ('Na tomto mst jsem oekval dvojteku.');
        POKUD_POKUD_EXPECTED: ShowMessage ('Na tomto mst jsem ekal slovo "pokud".');
        UNEXPECTED_FILE_END: ShowMessage ('Soubor neekan ukonen. Nezapomnl(a) jsi na ukonen nkterho blokovho pkazu nebo komente?');
        ZELVICKU_UNKNOWN_ACTION: ShowMessage ('Oekval jsem "ukaz" nebo "skryj".');
        CLOSING_BRACKET_EXPECTED: ShowMessage ('Na tomto mst jsem oekval uzavrac zvorku.');
        OPENING_BRACKET_EXPECTED: ShowMessage ('Na tomto mst jsem oekval otevrac zvorku.');
        COMPARISON_SIGN_EXPECTED: ShowMessage ('Na tomto mst jsem oekval znamnko porovnn.');
        UNKNOWN_FUNCTION: ShowMessage ('Neznm funkce.');
        DOKUD_KONEC_EXPECTED: ShowMessage ('Blok "dokud" mus bt zakonen pkazem "konec", ale j jej nikde nevidm.');
        DOKUD_COLON_EXPECTED: ShowMessage ('Na tomto mst jsem ekal dvojteku.');
        PROVADEJ_COLON_EXPECTED: ShowMessage ('Na tomto mst jsem ekal dvojteku.');
        PROVADEJ_NEZ_EXPECTED: ShowMessage ('Blok "provadej" mus bt zakonen pkazem "nez", ale j jej nikde nevidm.');
        NACTI_VARNAME_EXPECTED: ShowMessage ('Na tomto mst jsem oekval nzev promnn.');
        PRECTI_QUOTES_EXPECTED: ShowMessage ('Na tomto mst jsem oekval uvozovky.');
        NAPIS_QUOTES_EXPECTED: ShowMessage ('Na tomto mst jsem oekval uvozovky.');
    end;
end;


procedure ZpracovaniZdrojovehoKodu.hlaseniODTCisloException;
begin
    case ODTCisloException (aktE).errType of
        DIV_BY_ZERO: ShowMessage ('Chyba, dlen nulou.');
        INVALID_LOG_ARGUMENT: ShowMessage ('Chyba, nesprvn argument logaritmu.');
        INVALID_SQRT_ARGUMENT: ShowMessage ('Chyba, nesprvn argument odmocniny.');
        LOSS_OF_PRECISION: ShowMessage ('Na tomto mst jsem ekal cel slo. Desetinn zadat neme, muselo by bt toti zaokrouhleno.');
    end;
end;


procedure ZpracovaniZdrojovehoKodu.hlaseniVarsException;
begin
    case VarsException (aktE).errType of
        VAR_ALREADY_EXISTS: ShowMessage ('Promnn tohoto jmna u existuje!');
        VAR_NOT_FOUND: ShowMessage ('Promnnou tohoto jmna neznm.');
    end;
end;


procedure ZpracovaniZdrojovehoKodu.hlaseniRuntimeException;
begin
    case RuntimeException (aktE).errType of
        CALL_STACK_OVERFLOW: ShowMessage ('Petekl zsobnk voln funkc.');
        PARAM_STACK_OVERFLOW: ShowMessage ('Petekl zsobnk parametr.');
        VARIABLE_STACK_OVERFLOW: ShowMessage ('Petekl zsobnk promnnch.');
    end;
end;


procedure ZpracovaniZdrojovehoKodu.pustProceduru (p: Procedura);
begin
    try
        spustProceduru (p);
    except
        on E: ParseException do begin
            Synchronize (napoveda);
            aktE := E;
            Synchronize (hlaseniParseException);
        end;
        on E: ODTCisloException do begin
            Synchronize (napoveda);
            aktE := E;
            Synchronize (hlaseniODTCisloException);
        end;
        on E: VarsException do begin
            Synchronize (napoveda);
            aktE := E;
            Synchronize (hlaseniVarsException);
        end;
        on E: RuntimeException do begin
            Synchronize (napoveda);
            aktE := E;
            Synchronize (hlaseniRuntimeException);
        end;
    end; {of except}
end;


end.
 