unit UnitProcedura;

interface

uses Classes, UnitEditaceProcedury, UnitObecnyDatovyTyp, Forms, Controls,
UnitRetezcoveProcedury, UnitDefiniceVyjimek, Dialogs, UnitDialogUlozitProceduru;

type


Parametr = record
      nazev: String;
      typ:   ODTTyp;
end;


Procedura = class
  private
    editacniOkno: TForm2;
    hlavniOkno: TForm; {aby mohl posilat hlavnimu oknu, napr. ze projekt byl modifikovan}
    del: integer;  {delka kodu ve znacich, pro rychlejsi funkci delka}
    kodProcedury: TStringList; {sem se zkopiruje obsah TForm2.RichEdit1}
    jmeno: String;  {jmeno teto procedury}
    function ParamString: String;
    procedure ulozParametry;
    procedure ulozQuery(Sender: TObject);
  public
    parametry: array[1..MAXPARAM] of Parametr; {seznam parametru, ktere procedura bere}
    parametru: integer; {pocet parametru}
    constructor Create (AOwner: TComponent); overload;
    constructor Create (AOwner: TComponent; jmenoProc: String); overload;
    procedure Show; overload;
    procedure Show (zn: integer); overload;
    function uloz: boolean;
    function delka: integer;
    function cti (index: integer): char;
    function nactiProceduru (var vstupniSoubor: TextFile): String;
    procedure ulozProceduru (var vystupniSoubor: TextFile);
    procedure FormCloseQuery (Sender: TObject; var CanClose: Boolean);
    destructor Destroy; override;
end; {of Procedura}


implementation


procedure Procedura.Show (zn: integer);
{ukaze editacni okno a kurzor nastavi na pozici zn}
begin
    with editacniOkno do begin
        Show;
        RichEdit1.SetFocus;
        RichEdit1.SelStart := zn;
    end;
end;


function Procedura.nactiProceduru (var vstupniSoubor: TextFile): String;
{nacte proceduru ze souboru}
var procName: String;
var procParams: String;
var procSize: integer;
var procBody: TStrings;
var bodyRadek: String;
var i: integer;
begin
    procBody := TStringList.Create;
    Readln (vstupniSoubor, procName);
    Readln (vstupniSoubor, procParams);
    Readln (vstupniSoubor, procSize);
    for i := 0 to procSize - 1 do begin
        Readln (vstupniSoubor, bodyRadek);
        procBody.append (bodyRadek);
    end;
    with editacniOkno do begin
        Edit2.Text := procParams;
        Caption := 'Tv vlastn procedura: ' + procName;
        RichEdit1.Lines := procBody;
        uloz;
    end;
    nactiProceduru := procName;
    jmeno := procName;
end;


procedure Procedura.ulozProceduru (var vystupniSoubor: TextFile);
{ulozi proceduru do souboru}
var j: integer;
begin
    Writeln (vystupniSoubor, jmeno);
    Writeln (vystupniSoubor, paramString);
    Writeln (vystupniSoubor, kodProcedury.Count);
    for j := 0 to kodProcedury.Count - 1 do begin
        Writeln (vystupniSoubor, editacniOkno.RichEdit1.Lines[j]);
    end;
end;


procedure Procedura.ulozParametry;
{zkopiruje parametry procedury do zvlastni pormenne, odkud s nimi
 bude mozno lepe pracovat a odkud se nactou, pokud se uzivatel
 rozhodne zahodit zmeny}
var i: integer;
var nazev, typ: String;
begin
  i := 1;
  parametru := 0;
  with editacniOkno do begin
  while i <= length (Edit2.Text) do begin
    while Edit2.Text[i] = ' ' do inc (i);
    typ := '';
    while jeAlfNum (Edit2.Text[i]) do begin
        typ := typ + Edit2.Text[i];
        inc (i);
    end;
    while Edit2.Text[i] = ' ' do inc (i);
    nazev := '';
    inc (i); {preskocime dolar}
    while jeAlfNum (Edit2.Text[i]) do begin
        nazev := nazev + Edit2.Text[i];
        inc (i);
    end;
    while Edit2.Text[i] = ' ' do inc (i);
    if i < length (Edit2.Text) then inc (i); {preskocime carku}
    while Edit2.Text[i] = ' ' do inc (i);
    inc (parametru);
    parametry[parametru].nazev := nazev;
         if typ = 'cele' then parametry[parametru].typ := CISLO_CELE
    else if typ = 'logicka' then parametry[parametru].typ := LOGICKA_HODNOTA
    else if typ = 'desetinne' then parametry[parametru].typ := CISLO_DESETINNE
    else raise ParseException.Create (UNKNOWN_TYPE);
  end; {of while}
  end; {of with editacniOkno}
end;


function Procedura.uloz: boolean;
{zkopiruje obsah pole promennych a pole se zdrojovym kodem do
 zvlastnich promennych, zmeny tak zustanou zachovany (jinak by se
 pri dalsim otevreni okna ztratily)}
begin
  with editacniOkno do begin
  uloz := false;
  try
      ulozParametry;
      uloz := true;
      del := length (RichEdit1.Text);
      kodProcedury.Assign (RichEdit1.Lines);
      hlavniOkno.Tag := 1;
      RichEdit1.Modified := false;
      Edit2.Modified := false;
  except
      on E: ParseException do case E.errType of UNKNOWN_TYPE:
          ShowMessage ('Jeden nebo vce vstupnch parametr m neznm typ. Oprav si prosm hlaviku procedury, jinak ji nebudu moci uloit.');
      end; {of on}
  end; {of try}
  end; {of with editacniOkno}
end;


function Procedura.cti (index: integer): char;
{vrati index-ty znak kodu procedury}
begin
  with editacniOkno do begin
    try
        cti := RichEdit1.Text[index];
    except
        raise ParseException.Create (UNEXPECTED_FILE_END);
    end;
  end; {of with editacniOkno}
end;


constructor Procedura.Create (AOwner: TComponent);
begin
    inherited Create;
    del := 0;
    kodProcedury := TStringList.Create;
    editacniOkno := TForm2.Create (AOwner);
    editacniOkno.OnCloseQuery := FormCloseQuery;
    editacniOkno.Ulo1.OnClick := ulozQuery;
    hlavniOkno := TForm (AOwner);
end;


destructor Procedura.Destroy;
begin
    kodProcedury.Destroy;
    editacniOkno.Destroy;
end;


constructor Procedura.Create (AOwner: TComponent; jmenoProc: String);
{konstruktor pouzivany, je-li zapotrebi nastavit jmeno procedury}
begin
    Create (AOwner);
    jmeno := jmenoProc;
    editacniOkno.Caption := 'Tv vlastn procedura: ' + jmeno;
end;


function Procedura.paramString: String;
{vrati seznam parametru, ktere procedura bere v "lidstine". Tedy projde pole
 parametry a vrati jej ve formatu: typ_1._parametru jmeno_1._parametru,
 typ_2._parametru jmeno_2._parametru, ...}
var vysledek: String;
var i: integer;
begin
    vysledek := '';
    for i := 1 to parametru do begin
        if parametry[i].typ = CISLO_CELE then
            vysledek := vysledek + 'cele $'
        else if parametry[i].typ = CISLO_DESETINNE then
            vysledek := vysledek + 'desetinne $'
        else if parametry[i].typ = LOGICKA_HODNOTA then
            vysledek := vysledek + 'logicka $';
        vysledek := vysledek + parametry[i].nazev;
        if i < parametru then vysledek := vysledek + ', ';
    end; {of for}
    paramString := vysledek;
end;


procedure Procedura.FormCloseQuery (Sender: TObject; var CanClose: Boolean);
{pokud chce uzivatel zachovat zmeny, ulozi se, pokud ne, obnovi se
 stav, jaky byl pred posledni editaci -- nahraje se ze zvlastnich
 clenskych promennych}
begin
    with editacniOkno do begin
        if RichEdit1.Modified or Edit2.Modified then begin
            if Form3.ShowModal = mrYes then begin
                if not uloz then CanClose := false
            end else begin
                RichEdit1.Lines.Assign (kodProcedury);
                Edit2.Text := paramString;
            end; {of if showmModal}
        end; {of if modified}
    end; {of with editacniOkno}
end;


procedure Procedura.ulozQuery(Sender: TObject);
begin
    uloz;
end;


function Procedura.delka: integer;
{pro zrychleni -- funkce length se nemusi volat pri kazdem zavolani metody
 delka}
begin
    delka := del;
end;


procedure Procedura.Show;
begin
    editacniOkno.Show;
end;

end.
